"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StoreEntity = exports.Default = exports.Parse = exports.Validation = exports.onFocus = exports.onBlur = exports.onSubmit = exports.onChange = exports.Column = exports.createColumnObject = void 0;
const const_1 = require("./const");
const EleRef_1 = require("./EleRef");
let columnDefination = {};
function createColumnObject(propertyKey) {
    if (!columnDefination[propertyKey]) {
        columnDefination[propertyKey] = {};
    }
}
exports.createColumnObject = createColumnObject;
let Column = (type) => (target, propertyKey) => {
    createColumnObject(propertyKey);
    columnDefination[propertyKey][const_1.ENTITY_COLUMN.TYPE] = type;
    // columnDefination[propertyKey][ENTITY_COLUMN.MAXLENGTH]=maxLength;
};
exports.Column = Column;
let onChange = () => (target, propertyKey) => {
    createColumnObject(propertyKey);
    columnDefination[propertyKey][const_1.PROCESS_TYPE.ONCHANGE] = true;
    // columnDefination[propertyKey][ENTITY_COLUMN.MAXLENGTH]=maxLength;
};
exports.onChange = onChange;
let onSubmit = () => (target, propertyKey) => {
    createColumnObject(propertyKey);
    columnDefination[propertyKey][const_1.PROCESS_TYPE.ONSUBMIT] = true;
    // columnDefination[propertyKey][ENTITY_COLUMN.MAXLENGTH]=maxLength;
};
exports.onSubmit = onSubmit;
let onBlur = () => (target, propertyKey) => {
    createColumnObject(propertyKey);
    columnDefination[propertyKey][const_1.PROCESS_TYPE.ONBLUR] = true;
    // columnDefination[propertyKey][ENTITY_COLUMN.MAXLENGTH]=maxLength;
};
exports.onBlur = onBlur;
let onFocus = () => (target, propertyKey) => {
    createColumnObject(propertyKey);
    columnDefination[propertyKey][const_1.PROCESS_TYPE.ONFOCUS] = true;
    // columnDefination[propertyKey][ENTITY_COLUMN.MAXLENGTH]=maxLength;
};
exports.onFocus = onFocus;
let Validation = (cb) => (target, propertyKey) => {
    createColumnObject(propertyKey);
    columnDefination[propertyKey][const_1.ENTITY_COLUMN.VALIDATION] = cb;
};
exports.Validation = Validation;
let Parse = (cb) => (target, propertyKey) => {
    //console.log("parse=>",target)
    // target.prototype.parse=cb;
    createColumnObject(propertyKey);
    columnDefination[propertyKey][const_1.ENTITY_COLUMN.PARSE] = cb;
};
exports.Parse = Parse;
let Default = (value) => (target, propertyKey) => {
    createColumnObject(propertyKey);
    columnDefination[propertyKey][const_1.ENTITY_COLUMN.DEFAULT] = value;
};
exports.Default = Default;
let StoreEntity = (target) => {
    for (let key in columnDefination) {
        let el;
        if (columnDefination[key][const_1.ENTITY_COLUMN.TYPE] == const_1.REF_TYPE.INPUT || columnDefination[key][const_1.ENTITY_COLUMN.TYPE] == const_1.REF_TYPE.HIDDEN) {
            el = new EleRef_1.InputEleRef();
            if (columnDefination[key][const_1.PROCESS_TYPE.ONBLUR]) {
                el.eventObject.blur = true;
            }
            if (columnDefination[key][const_1.PROCESS_TYPE.ONCHANGE]) {
                el.eventObject.change = true;
            }
            if (columnDefination[key][const_1.PROCESS_TYPE.ONFOCUS]) {
                el.eventObject.focus = true;
            }
            if (columnDefination[key][const_1.PROCESS_TYPE.ONSUBMIT]) {
                el.eventObject.submit = true;
            }
            if (columnDefination[key][const_1.ENTITY_COLUMN.PARSE]) {
                el.parse = columnDefination[key][const_1.ENTITY_COLUMN.PARSE];
                //target.prototype[key][ENTITY_COLUMN.PARSE]=columnDefination[key][ENTITY_COLUMN.PARSE];
            }
            if (columnDefination[key][const_1.ENTITY_COLUMN.VALIDATION]) {
                el.validation = columnDefination[key][const_1.ENTITY_COLUMN.VALIDATION];
                //target[key][ENTITY_COLUMN.VALIDATION]=columnDefination[key][ENTITY_COLUMN.VALIDATION];
            }
            if (columnDefination[key][const_1.ENTITY_COLUMN.DEFAULT]) {
                el.defaultValue = columnDefination[key][const_1.ENTITY_COLUMN.DEFAULT];
                //target[key][ENTITY_COLUMN.DEFAULT]=columnDefination[key][ENTITY_COLUMN.DEFAULT];
            }
            if (columnDefination[key][const_1.ENTITY_COLUMN.TYPE] == const_1.REF_TYPE.HIDDEN) {
                let inpEle = document.createElement("input");
                inpEle.setAttribute("type", "hidden");
                el.bindRef(inpEle);
            }
        }
        else if (columnDefination[key][const_1.ENTITY_COLUMN.TYPE] == const_1.REF_TYPE.NON_INPUT) {
            el = new EleRef_1.EleRef();
        }
        if (el) {
            target.prototype[key] = el;
        }
    }
    target.prototype[const_1.ENTITY.DEFINATION] = columnDefination;
    columnDefination = {};
    //columnDefination={};
};
exports.StoreEntity = StoreEntity;
//# sourceMappingURL=Anotation.js.map