"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EleRef = exports.InputEleRef = void 0;
class InputEleRef {
    constructor() {
        this.eventObject = { change: false, blur: false, focus: false, submit: false };
    }
    bindRef(ele) {
        if (this.element != ele) {
            this.element = ele;
            this.element.value = this.defaultValue || null;
            if (this.eventObject.change) {
                this.element.addEventListener("change", (e) => {
                    let vstr = this.processExecution();
                    if (this.onChange) {
                        this.onChange(vstr, e);
                    }
                });
            }
            if (this.eventObject.blur) {
                this.element.addEventListener("blur", (e) => {
                    let vstr = this.processExecution();
                    if (this.onBlur) {
                        this.onBlur(vstr, e);
                    }
                });
            }
            if (this.eventObject.focus) {
                this.element.addEventListener("blur", (e) => {
                    let vstr = this.processExecution();
                    if (this.onFocus) {
                        this.onFocus(vstr, e);
                    }
                });
            }
        }
    }
    processExecution() {
        let vstr = null;
        if (this.parse) {
            this.element.value = this.parse(this.element.value);
        }
        if (this.validation) {
            vstr = this.validation(this.element.value);
        }
        return vstr;
    }
    getValue() {
        return this.element.value;
    }
    setValue(value) {
        this.element.value = value;
    }
}
exports.InputEleRef = InputEleRef;
class EleRef {
    bindRef(ele) {
        if (this.element != ele) {
            this.element = ele;
        }
    }
    getElement() {
        return this.element;
    }
}
exports.EleRef = EleRef;
//# sourceMappingURL=EleRef.js.map